#include <iostream>
#include <fstream> // output file

using namespace std;

/* Pieter Koopman, Radboud University Nijmegen
   October 2006
   Basis voor opgave 4 P1 2006: Finite State Machines
*/

// Types voor de representatie van een FSM

const int OutputLengte = 30;
typedef int State;
typedef char Input;
typedef char Output [OutputLengte];

const State EindState = -1;
const Input AnyChar = '%';

struct Trans
{
	Input in;
	State next;
	Output out;
};

const int Nstates = 20;
const int MaxTrans = 10;
typedef Trans Table [Nstates][MaxTrans];

State delta (Table table, State s, Input i)
{
	// zelf invullen
	return EindState;
}

void sigma (Table table, State s, Input i)
{
	// zelf invullen
}

void fsm (Table table, char input [])
{
	// zelf invullen
}
		
void fsmFile(Table table, char naam [])
{
	ifstream file(naam);
	if (!file.is_open())
	{
		cout << "De file \""<<naam<<"\" kon niet geopend worden!\n";
	    system("PAUSE");
	    exit(1);
	}
	// zelf iets beters invullen
	while (true)
	{
		char c = file.get();
		if (c==EOF)
			break;
		cout << c;
	}
	file.close();
}

bool gezond (Table table)
{
	return true;
}
	
int main(int argc, char *argv[])
{
	Table tableKat
	 = {{{'k',1,""},{'K',1,""},{'\0',EindState,".\n"},{AnyChar,0,""}}
	   ,{{'k',1,""},{'K',1,""},{'a',2,""},{'A',2,""},{'\0',EindState,".\n"},{AnyChar,0,""}}
	   ,{{'k',1,""},{'K',1,""},{'t',0,"kat"},{'T',0,"kat"},{'\0',EindState,".\n"},{AnyChar,0,""}}
	   };
	
	Table tableKopie = {{{EOF,EindState,"\n"},{AnyChar,0,"%"}}};

	Table tableEven
	 = {{{EOF,EindState,"even\n"},{'n',1,""},{'N',1,""},{AnyChar,0,""}}
	   ,{{EOF,EindState,"oneven\n"},{'n',0,""},{'N',0,""},{AnyChar,1,""}}
	   };
	
	Table tableHtml
	 = {{{AnyChar,EindState,""}} // zelf iets beters invullen
	   };

	fsmFile(tableHtml,"demo.txt");
	
    system("PAUSE");
    return EXIT_SUCCESS;
}
